<?php
 use Kunnu\Dropbox\Dropbox;
 use Kunnu\Dropbox\DropboxApp;
 use Kunnu\Dropbox\DropboxFile;
 use Kunnu\Dropbox\Exceptions\DropboxClientException;
 use Kunnu\Dropbox\Models\FileMetadata;
 use Kunnu\Dropbox\Models\FolderMetadata;
 class elFinderVolumeDropbox2 extends elFinderVolumeDriver {
 protected $driverId = 'db';
 protected $service = null;
 private $FETCH_OPTIONS = [];
 protected $tmp = '';
 public $netMountKey = '';
 public function __construct() {
 $opts = [ 'app_key' => '', 'app_secret' => '', 'access_token' => '', 'aliasFormat' => '%s@Dropbox', 'path' => '/', 'separator' => '/', 'acceptedName' => '#^[^/\\?*:|"<>]*[^./\\?*:|"<>]$#', 'rootCssClass' => 'elfinder-navbar-root-dropbox', 'publishPermission' => [ 'requested_visibility' => 'public', ], 'getThumbSize' => 'medium', ];
 $this->options = array_merge($this->options, $opts);
 $this->options['mimeDetect'] = 'internal';
 }
 protected function _db_splitPath($path) {
 $path = trim($path, '/');
 if ($path === '') {
 $dirname = '/';
 $basename = '';
 }
 else {
 $pos = strrpos($path, '/');
 if ($pos === false) {
 $dirname = '/';
 $basename = $path;
 }
 else {
 $dirname = '/' . substr($path, 0, $pos);
 $basename = substr($path, $pos + 1);
 }
 }
 return [$dirname, $basename];
 }
 private function _db_getFile($path) {
 if ($path === '/') {
 return true;
 }
 $res = false;
 try {
 $file = $this->service->getMetadata($path, $this->FETCH_OPTIONS);
 if ($file instanceof FolderMetadata || $file instanceof FileMetadata) {
 $res = $file;
 }
 return $res;
 }
 catch (DropboxClientException $e) {
 return false;
 }
 }
 protected function _db_parseRaw($raw) {
 $stat = [];
 $isFolder = false;
 if ($raw === true) {
 $isFolder = true;
 $stat['name'] = '';
 $stat['iid'] = '0';
 }
 $data = [];
 if (is_object($raw)) {
 $isFolder = $raw instanceof FolderMetadata;
 $data = $raw->getData();
 }
 elseif (is_array($raw)) {
 $isFolder = $raw['.tag'] === 'folder';
 $data = $raw;
 }
 if (isset($data['path_lower'])) {
 $stat['path'] = $data['path_lower'];
 }
 if (isset($data['name'])) {
 $stat['name'] = $data['name'];
 }
 if (isset($data['id'])) {
 $stat['iid'] = substr($data['id'], 3);
 }
 if ($isFolder) {
 $stat['mime'] = 'directory';
 $stat['size'] = 0;
 $stat['ts'] = 0;
 $stat['dirs'] = -1;
 }
 else {
 $stat['size'] = isset($data['size']) ? (int)$data['size'] : 0;
 if (isset($data['server_modified'])) {
 $stat['ts'] = strtotime($data['server_modified']);
 }
 elseif (isset($data['client_modified'])) {
 $stat['ts'] = strtotime($data['client_modified']);
 }
 else {
 $stat['ts'] = 0;
 }
 $stat['url'] = '1';
 }
 return $stat;
 }
 protected function _db_getThumbnail($path) {
 try {
 return $this->service->getThumbnail($path, $this->options['getThumbSize'])->getContents();
 }
 catch (DropboxClientException $e) {
 return false;
 }
 }
 protected function _db_joinName($dir, $displayName) {
 return rtrim($dir, '/') . '/' . $displayName;
 }
 public static function getTokenFromOauth1($app_key, $app_secret, $oauth1_token, $oauth1_secret) {
 $data = [ 'oauth1_token' => $oauth1_token, 'oauth1_token_secret' => $oauth1_secret, ];
 $auth = base64_encode($app_key . ':' . $app_secret);
 $ch = curl_init('https://api.dropboxapi.com/2/auth/token/from_oauth1');
 curl_setopt($ch, CURLOPT_POST, true);
 curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
 curl_setopt($ch, CURLOPT_HTTPHEADER, [ 'Content-Type: application/json', 'Authorization: Basic ' . $auth, ]);
 curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
 $result = curl_exec($ch);
 curl_close($ch);
 $res = $result ? json_decode($result, true) : [];
 return isset($res['oauth2_token']) ? $res['oauth2_token'] : false;
 }
 public function netmountPrepare($options) {
 if (empty($options['app_key']) && defined('ELFINDER_DROPBOX_APPKEY')) {
 $options['app_key'] = ELFINDER_DROPBOX_APPKEY;
 }
 if (empty($options['app_secret']) && defined('ELFINDER_DROPBOX_APPSECRET')) {
 $options['app_secret'] = ELFINDER_DROPBOX_APPSECRET;
 }
 if (!isset($options['pass'])) {
 $options['pass'] = '';
 }
 try {
 $this->session->start();
 $app = new DropboxApp($options['app_key'], $options['app_secret']);
 $dropbox = new Dropbox($app);
 $authHelper = $dropbox->getAuthHelper();
 if ($options['pass'] === 'reauth') {
 $options['pass'] = '';
 $this->session->set('Dropbox2AuthParams', [])->set('Dropbox2Tokens', []);
 }
 elseif ($options['pass'] === 'dropbox2') {
 $options['pass'] = '';
 }
 $options = array_merge($this->session->get('Dropbox2AuthParams', []), $options);
 if (!isset($options['tokens'])) {
 $options['tokens'] = $this->session->get('Dropbox2Tokens', []);
 $this->session->remove('Dropbox2Tokens');
 }
 $aToken = $options['tokens'];
 if (!is_array($aToken) || !isset($aToken['access_token'])) {
 $aToken = [];
 }
 $service = null;
 if ($aToken) {
 try {
 $dropbox->setAccessToken($aToken['access_token']);
 $this->session->set('Dropbox2AuthParams', $options);
 }
 catch (DropboxClientException $e) {
 $aToken = [];
 $options['tokens'] = [];
 if ($options['user'] !== 'init') {
 $this->session->set('Dropbox2AuthParams', $options);
 return ['exit' => true, 'error' => elFinder::ERROR_REAUTH_REQUIRE];
 }
 }
 }
 if ($options['user'] === 'init') {
 if (empty($options['url'])) {
 $options['url'] = elFinder::getConnectorUrl();
 }
 $callback = $options['url'] . '?cmd=netmount&protocol=dropbox2&host=1';
 if (!$aToken && empty($_GET['code'])) {
 $url = $authHelper->getAuthUrl($callback);
 $html = '<input id="elf-volumedriver-dropbox2-host-btn" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only" value="{msg:btnApprove}" type="button" onclick="window.open(\'' . $url . '\')">';
 $html .= '<script>
                        $("#' . $options['id'] . '").elfinder("instance").trigger("netmount", {protocol: "dropbox2", mode: "makebtn"});
                    </script>';
 if (empty($options['pass']) && $options['host'] !== '1') {
 $options['pass'] = 'return';
 $this->session->set('Dropbox2AuthParams', $options);
 return ['exit' => true, 'body' => $html];
 }
 else {
 $out = [ 'node' => $options['id'], 'json' => '{"protocol": "dropbox2", "mode": "makebtn", "body" : "' . str_replace($html, '"', '\\"') . '", "error" : "' . elFinder::ERROR_ACCESS_DENIED . '"}', 'bind' => 'netmount', ];
 return ['exit' => 'callback', 'out' => $out];
 }
 }
 else {
 if (!empty($_GET['code']) && isset($_GET['state'])) {
 $tokenObj = $authHelper->getAccessToken($_GET['code'], $_GET['state'], $callback);
 $options['tokens'] = [ 'access_token' => $tokenObj->getToken(), 'uid' => $tokenObj->getUid(), ];
 $this->session->set('Dropbox2Tokens', $options['tokens'])->set('Dropbox2AuthParams', $options);
 $out = [ 'node' => $options['id'], 'json' => '{"protocol": "dropbox2", "mode": "done", "reset": 1}', 'bind' => 'netmount', ];
 return ['exit' => 'callback', 'out' => $out];
 }
 $path = $options['path'];
 $folders = [];
 $listFolderContents = $dropbox->listFolder($path);
 $items = $listFolderContents->getItems();
 foreach ($items as $item) {
 $data = $item->getData();
 if ($data['.tag'] === 'folder') {
 $folders[$data['path_lower']] = $data['name'];
 }
 }
 natcasesort($folders);
 if ($options['pass'] === 'folders') {
 return ['exit' => true, 'folders' => $folders];
 }
 $folders = ['/' => '/'] + $folders;
 $folders = json_encode($folders);
 $json = '{"protocol": "dropbox2", "mode": "done", "folders": ' . $folders . '}';
 $options['pass'] = 'return';
 $html = 'Dropbox.com';
 $html .= '<script>
                        $("#' . $options['id'] . '").elfinder("instance").trigger("netmount", ' . $json . ');
                    </script>';
 $this->session->set('Dropbox2AuthParams', $options);
 return ['exit' => true, 'body' => $html];
 }
 }
 }
 catch (DropboxClientException $e) {
 $this->session->remove('Dropbox2AuthParams')->remove('Dropbox2Tokens');
 if (empty($options['pass'])) {
 return ['exit' => true, 'body' => '{msg:' . elFinder::ERROR_ACCESS_DENIED . '}' . ' ' . $e->getMessage()];
 }
 else {
 return ['exit' => true, 'error' => [elFinder::ERROR_ACCESS_DENIED, $e->getMessage()]];
 }
 }
 if (!$aToken) {
 return ['exit' => true, 'error' => elFinder::ERROR_REAUTH_REQUIRE];
 }
 if ($options['path'] === 'root') {
 $options['path'] = '/';
 }
 try {
 if ($options['path'] !== '/') {
 $file = $dropbox->getMetadata($options['path']);
 $name = $file->getName();
 }
 else {
 $name = 'root';
 }
 $options['alias'] = sprintf($this->options['aliasFormat'], $name);
 }
 catch (DropboxClientException $e) {
 return ['exit' => true, 'error' => $e->getMessage()];
 }
 foreach (['host', 'user', 'pass', 'id', 'offline'] as $key) {
 unset($options[$key]);
 }
 return $options;
 }
 public function netunmount($netVolumes, $key) {
 if ($tmbs = glob(rtrim($this->options['tmbPath'], '\\/') . DIRECTORY_SEPARATOR . $this->driverId . '_' . $this->options['tokens']['uid'] . '*.png')) {
 foreach ($tmbs as $file) {
 unlink($file);
 }
 }
 return true;
 }
 protected function init() {
 if (empty($this->options['app_key'])) {
 if (defined('ELFINDER_DROPBOX_APPKEY') && ELFINDER_DROPBOX_APPKEY) {
 $this->options['app_key'] = ELFINDER_DROPBOX_APPKEY;
 }
 else {
 return $this->setError('Required option "app_key" is undefined.');
 }
 }
 if (empty($this->options['app_secret'])) {
 if (defined('ELFINDER_DROPBOX_APPSECRET') && ELFINDER_DROPBOX_APPSECRET) {
 $this->options['app_secret'] = ELFINDER_DROPBOX_APPSECRET;
 }
 else {
 return $this->setError('Required option "app_secret" is undefined.');
 }
 }
 if (isset($this->options['tokens']) && is_array($this->options['tokens']) && !empty($this->options['tokens']['access_token'])) {
 $this->options['access_token'] = $this->options['tokens']['access_token'];
 }
 if (!$this->options['access_token']) {
 return $this->setError('Required option "access_token" or "refresh_token" is undefined.');
 }
 try {
 $aToken = $this->options['access_token'];
 $this->netMountKey = md5($aToken . '-' . $this->options['path']);
 $errors = [];
 if (!$this->service) {
 $app = new DropboxApp($this->options['app_key'], $this->options['app_secret'], $aToken);
 $this->service = new Dropbox($app);
 }
 }
 catch (DropboxClientException $e) {
 $errors[] = 'Dropbox error: ' . $e->getMessage();
 }
 catch (Exception $e) {
 $errors[] = $e->getMessage();
 }
 if (!$this->service) {
 $errors[] = 'Dropbox Service could not be loaded.';
 return $this->setError($errors);
 }
 $this->options['path'] = strtolower($this->options['path']);
 if ($this->options['path'] == 'root') {
 $this->options['path'] = '/';
 }
 $this->root = $this->options['path'] = $this->_normpath($this->options['path']);
 if (empty($this->options['alias'])) {
 $this->options['alias'] = sprintf($this->options['aliasFormat'], ($this->options['path'] === '/') ? 'root' : $this->_basename($this->options['path']));
 }
 $this->rootName = $this->options['alias'];
 if (!empty($this->options['tmpPath'])) {
 if ((is_dir($this->options['tmpPath']) || mkdir($this->options['tmpPath'])) && is_writable($this->options['tmpPath'])) {
 $this->tmp = $this->options['tmpPath'];
 }
 }
 if (!$this->tmp && ($tmp = elFinder::getStaticVar('commonTempPath'))) {
 $this->tmp = $tmp;
 }
 $this->options['syncChkAsTs'] = false;
 $this->options['lsPlSleep'] = max(10, $this->options['lsPlSleep']);
 $this->options['useRemoteArchive'] = true;
 return true;
 }
 protected function configure() {
 parent::configure();
 if (!$this->tmp && $this->tmbPathWritable) {
 $this->tmp = $this->tmbPath;
 }
 if ($this->isMyReload()) {
 }
 }
 public function umount() {
 }
 protected function cacheDir($path) {
 $this->dirsCache[$path] = [];
 $hasDir = false;
 $res = $this->service->listFolder($path, $this->FETCH_OPTIONS);
 if ($res) {
 $items = $res->getItems()->all();
 foreach ($items as $raw) {
 if ($stat = $this->_db_parseRaw($raw)) {
 $mountPath = $this->_joinPath($path, $stat['name']);
 $stat = $this->updateCache($mountPath, $stat);
 if (empty($stat['hidden']) && $path !== $mountPath) {
 if (!$hasDir && $stat['mime'] === 'directory') {
 $hasDir = true;
 }
 $this->dirsCache[$path][] = $mountPath;
 }
 }
 }
 }
 if (isset($this->sessionCache['subdirs'])) {
 $this->sessionCache['subdirs'][$path] = $hasDir;
 }
 return $this->dirsCache[$path];
 }
 protected function doSearch($path, $q, $mimes) {
 if (!empty($this->doSearchCurrentQuery['matchMethod']) || $mimes) {
 return parent::doSearch($path, $q, $mimes);
 }
 $timeout = $this->options['searchTimeout'] ? $this->searchStart + $this->options['searchTimeout'] : 0;
 $searchRes = $this->service->search($path, $q, ['start' => 0, 'max_results' => 1000]);
 $items = $searchRes->getItems();
 $more = $searchRes->hasMoreItems();
 while ($more) {
 if ($timeout && $timeout < time()) {
 $this->setError(elFinder::ERROR_SEARCH_TIMEOUT, $this->_path($path));
 break;
 }
 $searchRes = $this->service->search($path, $q, ['start' => $searchRes->getCursor(), 'max_results' => 1000]);
 $more = $searchRes->hasMoreItems();
 $items = $items->merge($searchRes->getItems());
 }
 $result = [];
 foreach ($items as $raw) {
 if ($stat = $this->_db_parseRaw($raw->getMetadata())) {
 $stat = $this->updateCache($stat['path'], $stat);
 if (empty($stat['hidden'])) {
 $result[] = $stat;
 }
 }
 }
 return $result;
 }
 protected function copy($src, $dst, $name) {
 $srcStat = $this->stat($src);
 $target = $this->_joinPath($dst, $name);
 $tgtStat = $this->stat($target);
 if ($tgtStat) {
 if ($srcStat['mime'] === 'directory') {
 return parent::copy($src, $dst, $name);
 }
 else {
 $this->_unlink($target);
 }
 }
 $this->clearcache();
 if ($res = $this->_copy($src, $dst, $name)) {
 $this->added[] = $this->stat($target);
 $res = $target;
 }
 return $res;
 }
 protected function remove($path, $force = false, $recursive = false) {
 $stat = $this->stat($path);
 $stat['realpath'] = $path;
 $this->rmTmb($stat);
 $this->clearcache();
 if (empty($stat)) {
 return $this->setError(elFinder::ERROR_RM, $this->_path($path), elFinder::ERROR_FILE_NOT_FOUND);
 }
 if (!$force && !empty($stat['locked'])) {
 return $this->setError(elFinder::ERROR_LOCKED, $this->_path($path));
 }
 if ($stat['mime'] == 'directory') {
 if (!$recursive && !$this->_rmdir($path)) {
 return $this->setError(elFinder::ERROR_RM, $this->_path($path));
 }
 }
 else {
 if (!$recursive && !$this->_unlink($path)) {
 return $this->setError(elFinder::ERROR_RM, $this->_path($path));
 }
 }
 $this->removed[] = $stat;
 return true;
 }
 protected function createTmb($path, $stat) {
 if (!$stat || !$this->canCreateTmb($path, $stat)) {
 return false;
 }
 $name = $this->tmbname($stat);
 $tmb = $this->tmbPath . DIRECTORY_SEPARATOR . $name;
 if (!$data = $this->_db_getThumbnail($path)) {
 return false;
 }
 if (!file_put_contents($tmb, $data)) {
 return false;
 }
 $tmbSize = $this->tmbSize;
 if (($s = getimagesize($tmb)) == false) {
 return false;
 }
 $result = true;
 if ($s[0] <= $tmbSize && $s[1] <= $tmbSize) {
 $result = $this->imgSquareFit($tmb, $tmbSize, $tmbSize, 'center', 'middle', $this->options['tmbBgColor'], 'png');
 }
 else {
 if ($this->options['tmbCrop']) {
 if (!(($s[0] > $tmbSize && $s[1] <= $tmbSize) || ($s[0] <= $tmbSize && $s[1] > $tmbSize)) || ($s[0] > $tmbSize && $s[1] > $tmbSize)) {
 $result = $this->imgResize($tmb, $tmbSize, $tmbSize, true, false, 'png');
 }
 if ($result && ($s = getimagesize($tmb)) != false) {
 $x = $s[0] > $tmbSize ? intval(($s[0] - $tmbSize) / 2) : 0;
 $y = $s[1] > $tmbSize ? intval(($s[1] - $tmbSize) / 2) : 0;
 $result = $this->imgCrop($tmb, $tmbSize, $tmbSize, $x, $y, 'png');
 }
 }
 else {
 $result = $this->imgResize($tmb, $tmbSize, $tmbSize, true, true, 'png');
 }
 if ($result) {
 $result = $this->imgSquareFit($tmb, $tmbSize, $tmbSize, 'center', 'middle', $this->options['tmbBgColor'], 'png');
 }
 }
 if (!$result) {
 unlink($tmb);
 return false;
 }
 return $name;
 }
 protected function tmbname($stat) {
 $name = $this->driverId . '_';
 if (isset($this->options['tokens']) && is_array($this->options['tokens'])) {
 $name .= $this->options['tokens']['uid'];
 }
 return $name . md5($stat['iid']) . $stat['ts'] . '.png';
 }
 public function getContentUrl($hash, $options = []) {
 if (!empty($options['onetime']) && $this->options['onetimeUrl']) {
 return parent::getContentUrl($hash, $options);
 }
 if (!empty($options['temporary'])) {
 $url = parent::getContentUrl($hash, $options);
 if ($url) {
 return $url;
 }
 }
 $file = $this->file($hash);
 if (($file = $this->file($hash)) !== false && (!$file['url'] || $file['url'] == 1)) {
 $path = $this->decode($hash);
 $url = '';
 try {
 $res = $this->service->postToAPI('/sharing/list_shared_links', ['path' => $path, 'direct_only' => true])->getDecodedBody();
 if ($res && !empty($res['links'])) {
 foreach ($res['links'] as $link) {
 if (isset($link['link_permissions']) && isset($link['link_permissions']['requested_visibility']) && $link['link_permissions']['requested_visibility']['.tag'] === $this->options['publishPermission']['requested_visibility']) {
 $url = $link['url'];
 break;
 }
 }
 }
 if (!$url) {
 $res = $this->service->postToAPI('/sharing/create_shared_link_with_settings', ['path' => $path, 'settings' => $this->options['publishPermission']])->getDecodedBody();
 if (isset($res['url'])) {
 $url = $res['url'];
 }
 }
 if ($url) {
 $url = str_replace('www.dropbox.com', 'dl.dropboxusercontent.com', $url);
 $url = str_replace('?dl=0', '', $url);
 return $url;
 }
 }
 catch (DropboxClientException $e) {
 return $this->setError('Dropbox error: ' . $e->getMessage());
 }
 }
 return false;
 }
 public function debug() {
 $res = parent::debug();
 if (isset($this->options['tokens']) && !empty($this->options['tokens']['uid'])) {
 $res['Dropbox uid'] = $this->options['tokens']['uid'];
 $res['access_token'] = $this->options['tokens']['access_token'];
 }
 return $res;
 }
 protected function _dirname($path) {
 list($dirname) = $this->_db_splitPath($path);
 return $dirname;
 }
 protected function _basename($path) {
 list(, $basename) = $this->_db_splitPath($path);
 return $basename;
 }
 protected function _joinPath($dir, $name) {
 return rtrim($dir, '/') . '/' . strtolower($name);
 }
 protected function _normpath($path) {
 return '/' . ltrim($path, '/');
 }
 protected function _relpath($path) {
 if ($path === $this->root) {
 return '';
 }
 else {
 return ltrim(substr($path, strlen($this->root)), '/');
 }
 }
 protected function _abspath($path) {
 if ($path === '/') {
 return $this->root;
 }
 else {
 return $this->_joinPath($this->root, $path);
 }
 }
 protected function _path($path) {
 $path = $this->_normpath(substr($path, strlen($this->root)));
 return $path;
 }
 protected function _inpath($path, $parent) {
 return $path == $parent || strpos($path, $parent . '/') === 0;
 }
 protected function _stat($path) {
 if ($raw = $this->_db_getFile($path)) {
 return $this->_db_parseRaw($raw);
 }
 return false;
 }
 protected function _subdirs($path) {
 $hasdir = false;
 try {
 $res = $this->service->listFolder($path);
 if ($res) {
 $items = $res->getItems();
 foreach ($items as $raw) {
 if ($raw instanceof FolderMetadata) {
 $hasdir = true;
 break;
 }
 }
 }
 }
 catch (DropboxClientException $e) {
 $this->setError('Dropbox error: ' . $e->getMessage());
 }
 return $hasdir;
 }
 protected function _dimensions($path, $mime) {
 if (strpos($mime, 'image') !== 0) {
 return '';
 }
 $ret = '';
 if ($data = $this->_getContents($path)) {
 $tmp = $this->getTempFile();
 file_put_contents($tmp, $data);
 $size = getimagesize($tmp);
 if ($size) {
 $ret = array('dim' => $size[0] . 'x' . $size[1]);
 $srcfp = fopen($tmp, 'rb');
 if ($subImgLink = $this->getSubstituteImgLink(elFinder::$currentArgs['target'], $size, $srcfp)) {
 $ret['url'] = $subImgLink;
 }
 }
 }
 return $ret;
 }
 protected function _scandir($path) {
 return isset($this->dirsCache[$path]) ? $this->dirsCache[$path] : $this->cacheDir($path);
 }
 protected function _fopen($path, $mode = 'rb') {
 if ($mode === 'rb' || $mode === 'r') {
 if ($link = $this->service->getTemporaryLink($path)) {
 $access_token = $this->service->getAccessToken();
 if ($access_token) {
 $data = array( 'target' => $link->getLink(), 'headers' => array('Authorization: Bearer ' . $access_token), );
 return elFinder::getStreamByUrl($data);
 }
 }
 }
 return false;
 }
 protected function _fclose($fp, $path = '') {
 fclose($fp);
 }
 protected function _mkdir($path, $name) {
 try {
 return $this->service->createFolder($this->_db_joinName($path, $name))->getPathLower();
 }
 catch (DropboxClientException $e) {
 return $this->setError('Dropbox error: ' . $e->getMessage());
 }
 }
 protected function _mkfile($path, $name) {
 return $this->_save($this->tmpfile(), $path, $name, []);
 }
 protected function _symlink($target, $path, $name) {
 return false;
 }
 protected function _copy($source, $targetDir, $name) {
 try {
 $this->service->copy($source, $this->_db_joinName($targetDir, $name))->getPathLower();
 }
 catch (DropboxClientException $e) {
 return $this->setError('Dropbox error: ' . $e->getMessage());
 }
 return true;
 }
 protected function _move($source, $targetDir, $name) {
 try {
 return $this->service->move($source, $this->_db_joinName($targetDir, $name))->getPathLower();
 }
 catch (DropboxClientException $e) {
 return $this->setError('Dropbox error: ' . $e->getMessage());
 }
 }
 protected function _unlink($path) {
 try {
 $this->service->delete($path);
 return true;
 }
 catch (DropboxClientException $e) {
 return $this->setError('Dropbox error: ' . $e->getMessage());
 }
 return true;
 }
 protected function _rmdir($path) {
 return $this->_unlink($path);
 }
 protected function _save($fp, $path, $name, $stat) {
 try {
 $info = stream_get_meta_data($fp);
 if (empty($info['uri']) || preg_match('#^[a-z0-9.-]+://#', $info['uri'])) {
 if ($filepath = $this->getTempFile()) {
 $_fp = fopen($filepath, 'wb');
 stream_copy_to_stream($fp, $_fp);
 fclose($_fp);
 }
 }
 else {
 $filepath = $info['uri'];
 }
 $dropboxFile = new DropboxFile($filepath);
 if ($name === '') {
 $fullpath = $path;
 }
 else {
 $fullpath = $this->_db_joinName($path, $name);
 }
 return $this->service->upload($dropboxFile, $fullpath, ['mode' => 'overwrite'])->getPathLower();
 }
 catch (DropboxClientException $e) {
 return $this->setError('Dropbox error: ' . $e->getMessage());
 }
 }
 protected function _getContents($path) {
 $contents = '';
 try {
 $file = $this->service->download($path);
 $contents = $file->getContents();
 }
 catch (Exception $e) {
 return $this->setError('Dropbox error: ' . $e->getMessage());
 }
 return $contents;
 }
 protected function _filePutContents($path, $content) {
 $res = false;
 if ($local = $this->getTempFile($path)) {
 if (file_put_contents($local, $content, LOCK_EX) !== false && ($fp = fopen($local, 'rb'))) {
 clearstatcache();
 $name = '';
 $stat = $this->stat($path);
 if ($stat) {
 $path = $this->_dirname($path);
 $name = $stat['name'];
 }
 $res = $this->_save($fp, $path, $name, []);
 fclose($fp);
 }
 file_exists($local) && unlink($local);
 }
 return $res;
 }
 protected function _checkArchivers() {
 return [];
 }
 protected function _chmod($path, $mode) {
 return false;
 }
 protected function _unpack($path, $arc) {
 die('Not yet implemented. (_unpack)');
 }
 protected function _findSymlinks($path) {
 die('Not yet implemented. (_findSymlinks)');
 }
 protected function _extract($path, $arc) {
 die('Not yet implemented. (_extract)');
 }
 protected function _archive($dir, $files, $name, $arc) {
 die('Not yet implemented. (_archive)');
 }
 }
 